;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Aramaki						
;							
;Uses first extra bit: YES				
;Clear: Normal			
;Set: Pounds the ground
;
;Notes:
;X position determines the range of attack	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite data		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_SIZE		dcb $14,$01,$14,$01
			dcb $14,$01,$01,$01
			dcb $14,$01,$01,$01
SPRITE_X_POS		dcb $00,$1C,$20,$14
			dcb $00,$1C,$20,$14
			dcb $10,$02,$00,$08
SPRITE_Y_POS		dcb $00,$10,$00,$10
			dcb $00,$10,$10,$10
			dcb $00,$10,$10,$10
SPRITE_TIMER		dcb $20,$08,$20,$08
FIRST_TIMER		= $20

ORIG_X_LOW		= $1504
ORIG_X_HIGH		= $151C
ORIG_Y_LOW		= $1534
ORIG_Y_HIGH		= $1570

SHAKE_TIMER		= $24
SPRITE_LOCK		= $40	;SHAKE_TIMER + SPRITE_LOCK = $00FFȉ

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			LDA $7FAB10,x
			AND #$04
			BEQ NOT_EXTRA_INIT
			INC $157C,x
NOT_EXTRA_INIT		LDA #FIRST_TIMER
			STA $1540,x
			LDA $E4,x
			STA ORIG_X_LOW,x
			LDA $14E0,x
			STA ORIG_X_HIGH,x
			LDA $D8,x
			STA ORIG_Y_LOW,x
			LDA $14D4,x
			STA ORIG_Y_HIGH,x
			LDA $E4,x
			LSR A
			LSR A
			LSR A
			LSR A
			AND #$03
			CMP #$03
			BNE INIT_LABEL00
			LDA #$00
INIT_LABEL00		STA $1594,x
			CMP #$02
			BNE INIT_END
			LDA $E4,x
			CLC
			ADC #$10
			STA $E4,x
			LDA $14E0,x
			ADC #$00
			STA $14E0,x
INIT_END		RTL

			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			JSR SPRITE_GFX
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;Main sprite routine	;
;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN			RTS
SPRITE_ROUTINE		LDA $14C8,x
			CMP #$08
			BNE RETURN
			LDA $9D
			BNE RETURN
			JSR SUB_OFF_SCREEN_X0
			JSL $018032

			LDA $1540,x
			BEQ LABEL_01
			JMP LABEL_00

LABEL_01		LDA $157C,x
			BEQ NOT_EXTRA
			JSR SUB_HORZ_POS
			CLC
			ADC.w #$0080
			CMP.w #$0100
			SEP #$20
			BCS LABEL_02
			LDA $1558,x
			BEQ NOT_EXTRA
			BRA LABEL_00
LABEL_02		LDA $C2,x
			AND #$01
			BEQ LABEL_00

NOT_EXTRA		LDA $C2,x
			INC A
			AND #$03
			STA $C2,x
			TAY
			LDA SPRITE_TIMER,y
			STA $1540,x
			LDA $1594,x
			ASL A
			ASL A
			STA $03
			TYA
			CLC
			ADC $03
			TAY
			LDA ORIG_X_LOW,x
			CLC
			ADC SPRITE_X_POS,y
			STA $E4,x
			LDA ORIG_X_HIGH,x
			ADC #$00
			STA $14E0,x
			LDA ORIG_Y_LOW,x
			SEC
			SBC SPRITE_Y_POS,y
			STA $D8,x
			LDA ORIG_Y_HIGH,x
			SBC #$00
			STA $14D4,x

			LDA $157C,x
			BEQ LABEL_00

			TYA
			AND #$01
			BNE LABEL_00
			LDA #SHAKE_TIMER
			TAY
			STA $1887
			CLC
			ADC #SPRITE_LOCK
			STA $1558,x
			LDA #$09
			STA $1DFC
			LDA $77
			AND #$04
			BEQ LABEL_00
			STY $18BD

LABEL_00		LDA $1594,x
			ASL A
			ASL A
			CLC
			ADC $C2,x
			TAY
			LDA SPRITE_SIZE,y
			STA $1662,x

			JSL $01A7DC

			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

TILE_MAP		dcb $90,$91,$A0,$A2,$84,$86,$E0,$A6,$80,$81,$82,$A4,$88,$8A,$A8,$A9
			dcb $90,$91,$A0,$A2,$84,$86,$E0,$A6,$C0,$D0,$C1,$E1,$88,$8A,$A8,$A9
			dcb $80,$81,$82,$A4,$88,$8A,$A8,$A9,$C3,$C4,$E3,$F0,$84,$86,$E0,$A6
TILE_SIZE		dcb $00,$00,$02,$02,$02,$02,$00,$02,$00,$00,$02,$02,$02,$02,$02,$02
			dcb $00,$00,$02,$02,$02,$02,$00,$02,$00,$00,$02,$02,$02,$02,$02,$02
			dcb $00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02,$00,$02,$02,$00,$02
HORZ_DISP		dcb $00,$08,$00,$10,$F0,$00,$F8,$00,$10,$18,$00,$10,$00,$10,$00,$08
			dcb $00,$08,$00,$10,$F0,$00,$F8,$00,$F8,$F8,$00,$00,$00,$10,$00,$08
			dcb $10,$18,$00,$10,$00,$10,$00,$08,$00,$08,$00,$10,$F0,$00,$F8,$00
VERT_DISP		dcb $F8,$F8,$00,$00,$00,$00,$10,$10,$F8,$F8,$00,$00,$00,$00,$10,$10
			dcb $F8,$F8,$00,$00,$00,$00,$10,$10,$00,$08,$00,$10,$00,$00,$10,$10
			dcb $F8,$F8,$00,$00,$00,$00,$10,$10,$00,$00,$10,$18,$00,$00,$10,$10

SPRITE_GFX		JSR GET_DRAW_INFO
			LDA $C2,x
			ASL A
			ASL A
			STA $03
			LDA $1594,x
			ASL A
			ASL A
			ASL A
			ASL A
			CLC
			ADC $03
			STA $03

			PHX
			LDX #$03
GFX_LOOP		PHX
			TXA
			CLC
			ADC $03
			TAX

			PHY
			TYA
			LSR A
			LSR A
			TAY
			LDA TILE_SIZE,x
			STA $0460,y
			PLY

			LDA $00
			CLC
			ADC HORZ_DISP,x
			STA $0300,y

			LDA $01
			CLC
			ADC VERT_DISP,x
			STA $0301,y

			LDA TILE_MAP,x
			STA $0302,y

			LDX $15E9
			LDA $15F6,x
			ORA $64
			STA $0303,y

			PLX
			INY
			INY
			INY
			INY
			DEX
			BPL GFX_LOOP

			PLX
			LDA #$03
			LDY #$FF
			JSL $01B7B3
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;		Y = index to sprite OAM ($300)
;		$00 = sprite x position relative to screen boarder
;		$01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1			dcb $0C,$1C
SPR_T2			dcb $01,$02

GET_DRAW_INFO		STZ $186C,x
			STZ $15A0,x
			LDA $E4,x
			CMP $1A
			LDA $14E0,x
			SBC $1B
			BEQ ON_SCREEN_X
			INC $15A0,x

ON_SCREEN_X		LDA $14E0,x
			XBA
			LDA $E4,x
			REP #$20
			SEC
			SBC $1A
			CLC
			ADC.W #$0040
			CMP.W #$0180
			SEP #$20
			ROL A
			AND #$01
			STA $15C4,x
			BNE INVALID

			LDY #$00
			LDA $1662,x
			AND #$20
			BEQ ON_SCREEN_LOOP
			INY
ON_SCREEN_LOOP		LDA $D8,x
			CLC
			ADC SPR_T1,y
			PHP
 			CMP $1C
			ROL $00
			PLP
			LDA $14D4,x
			ADC #$00
			LSR $00
			SBC $1D
			BEQ ON_SCREEN_Y
			LDA $186C,x
			ORA SPR_T2,y
			STA $186C,x
ON_SCREEN_Y		DEY
			BPL ON_SCREEN_LOOP

			LDY $15EA,x
			LDA $E4,x
			SEC
			SBC $1A
			STA $00
			LDA $D8,x
			SEC
			SBC $1C
			STA $01
			RTS

INVALID			PLA
			PLA
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12			dcb $40,$B0
SPR_T13			dcb $01,$FF
SPR_T14			dcb $30,$C0,$A0,$C0,$A0,$F0,$60,$90
			dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15			dcb $01,$FF,$01,$FF,$01,$FF,$01,$FF
			dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0	STZ $03

START_SUB		JSR SUB_IS_OFF_SCREEN
			BEQ RETURN_35
			LDA $5B
			AND #$01
			BNE VERTICAL_LEVEL
			LDA $D8,x
			CLC
			ADC #$50
			LDA $14D4,x
			ADC #$00
			CMP #$02
			BPL ERASE_SPRITE
			LDA $167A,x
			AND #$04
			BNE RETURN_35
			LDA $13
			AND #$01
			ORA $03
			STA $01
			TAY
  			LDA $1A
			CLC
			ADC SPR_T14,y
			ROL $00
			CMP $E4,x
			PHP
			LDA $1B
			LSR $00
			ADC SPR_T15,y
			PLP
			SBC $14E0,x
			STA $00
			LSR $01
			BCC SPR_L31
			EOR #$80
			STA $00
SPR_L31			LDA $00
			BPL RETURN_35
ERASE_SPRITE		LDA $14C8,x
			CMP #$08
			BCC KILL_SPRITE
			LDY $161A,x
			CPY #$FF
			BEQ KILL_SPRITE
			LDA #$00
			STA $1938,y
KILL_SPRITE		STZ $14C8,x
RETURN_35		RTS

VERTICAL_LEVEL		LDA $167A,x
			AND #$04
			BNE RETURN_35
			LDA $13
			LSR A
			BCS RETURN_35
			LDA $E4,x
			CMP #$00
			LDA $14E0,x
			SBC #$00
			CMP #$02
			BCS ERASE_SPRITE
			LDA $13
			LSR A
			AND #$01
			STA $01
			TAY
			LDA $1C
			CLC
			ADC SPR_T12,y
			ROL $00
			CMP $D8,x
			PHP
			LDA.W $001D
			LSR $00
			ADC SPR_T13,y
			PLP
			SBC $14D4,x
			STA $00
			LDY $01
			BEQ SPR_L38
			EOR #$80
  			STA $00
SPR_L38 		LDA $00
			BPL RETURN_35
			BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN	LDA $15A0,x
			ORA $186C,x
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sub horz pos		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDA $E4,x
			STA $00
			LDA $14E0,x
			STA $01
			REP #$20
			LDA $94
			SEC
			SBC $00
			STA $0E
			RTS